Overview | Package | Class | Tree | Deprecated | Index | Help
| J avolution v5.2 (J2SE 1.5+)
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javolution.lang
Interface Reusable

All Known Implementing Classes:
  AppendableWriter, CharSequenceReader, FastList, FastMap, FastSet, FastTable, SAX2ReaderImpl, TextBuilder, UTF8ByteBufferReader, UTF8ByteBufferWriter, UTF8StreamReader, UTF8StreamWriter, XMLBinding, XMLObjectReader, XMLObjectWriter, XMLReaderImpl, XMLReferenceResolver, XMLStreamReaderImpl, XMLStreamWriterImpl

    public interface Reusable

This interfaces identifies mutable objects capable of being used again or repeatedly; once `reset`, reusable objects behave as if they were brand-new.

Reusable instances should not allocate new internal objects after creation except for the purpose of increasing their internal capacities. In such case the new allocations have to be performed in the same memory areas as the reusable objects themselves (necessary to avoid memory leaks or memory clashes when running on RTSJ VMs). For example:``

         import javax.realtime.MemoryArea;
         public class Targets implements Reusable {
             private Target[] _targets = new Target[32];
             private int _count;
             public void add(Target target) {
                 if (_count >= _targets.length) capacityOverflow();
                 _targets[_count++] = target;
             }
             private void capacityOverflow() {
                  MemoryArea.getMemoryArea(this).executeInArea(new Runnable() {
                      public void run() {
                           Target[] tmp = new Target[_targets.length * 2];
                           System.arraycopy(_targets, 0, tmp, 0, _count);
                           _targets = tmp;
                      }
                  });
             }
             ...
         }

Instances of this class can safely reside in permanent memory (e.g. `static` members) or be an integral part of a higher level component. For example:``

         public class XMLFormat {
              // RTSJ Unsafe! Memory leaks (when entries removed) or IllegalAssignmentError (when new entries while in ScopedArea).
              static HashMap<Class, XMLFormat> ClassToFormat = HashMap<Class, XMLFormat>();

              // RTSJ safe! FastMap is Reusable. Removed entries are internally recycled, new entries are in ImmortalMemory.
              static FastMap<Class, XMLFormat> ClassToFormat = FastMap<Class, XMLFormat>();
         }

Reusable objects can also be allocated on the stack providing that their `factory` cleanup method calls the `reset` method. For example:``

         public class Foo implements Reusable {
             private static final ObjectFactory<Foo> FACTORY = new ObjectFactory<Foo>() {
                 protected Foo create() {
                     return new Foo();
                 }
                 protected void cleanup(Foo obj) {
                     obj.reset();
                 }
             };
             public static Foo newInstance() {
                 return FACTORY.object(); // On the "stack" when executing in a StackContext.
             }
             ...
         }

Version:
  3.7, January 1, 2006
Author:
  Jean-Marie Dautelle

Method Summary
`void` | `reset()` Resets the internal state of this object to its default values.

Method Detail

### reset

    void reset()

  Resets the internal state of this object to its default values.

Overview | Package | Class | Tree | Deprecated | Index | Help
| J avolution v5.2 (J2SE 1.5+)
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2005 - 2007 Javolution.